Index: NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/AMM12/EXPREF/nemo_rstw.xml
===================================================================
--- NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/AMM12/EXPREF/nemo_rstw.xml	(revision 11924)
+++ NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/AMM12/EXPREF/nemo_rstw.xml	(revision 11924)
@@ -0,0 +1,5 @@
+<context id="nemo_rstw">
+  
+    <grid_definition src="./grid_def_nemo.xml"/>
+    
+</context>
Index: NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/AMM12/EXPREF/si3_rst.xml
===================================================================
--- NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/AMM12/EXPREF/si3_rst.xml	(revision 11924)
+++ NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/AMM12/EXPREF/si3_rst.xml	(revision 11924)
@@ -0,0 +1,5 @@
+<context id="si3_rst">
+  
+    <grid_definition src="./grid_def_nemo.xml"/>
+    
+</context>
Index: NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/ORCA2_SAS_ICE/EXPREF/nemo_rstw.xml
===================================================================
--- NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/ORCA2_SAS_ICE/EXPREF/nemo_rstw.xml	(revision 11924)
+++ NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/ORCA2_SAS_ICE/EXPREF/nemo_rstw.xml	(revision 11924)
@@ -0,0 +1,5 @@
+<context id="nemo_rstw">
+  
+    <grid_definition src="./grid_def_nemo.xml"/>
+    
+</context>
Index: NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/ORCA2_SAS_ICE/EXPREF/si3_rst.xml
===================================================================
--- NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/ORCA2_SAS_ICE/EXPREF/si3_rst.xml	(revision 11924)
+++ NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/ORCA2_SAS_ICE/EXPREF/si3_rst.xml	(revision 11924)
@@ -0,0 +1,5 @@
+<context id="si3_rst">
+  
+    <grid_definition src="./grid_def_nemo.xml"/>
+    
+</context>
Index: NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/SPITZ12/EXPREF/nemo_rstw.xml
===================================================================
--- NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/SPITZ12/EXPREF/nemo_rstw.xml	(revision 11924)
+++ NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/SPITZ12/EXPREF/nemo_rstw.xml	(revision 11924)
@@ -0,0 +1,5 @@
+<context id="nemo_rstw">
+  
+    <grid_definition src="./grid_def_nemo.xml"/>
+    
+</context>
Index: NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/SPITZ12/EXPREF/si3_rst.xml
===================================================================
--- NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/SPITZ12/EXPREF/si3_rst.xml	(revision 11924)
+++ NEMO/branches/2019/dev_r11756_SI3restart_XIOS/cfgs/SPITZ12/EXPREF/si3_rst.xml	(revision 11924)
@@ -0,0 +1,5 @@
+<context id="si3_rst">
+  
+    <grid_definition src="./grid_def_nemo.xml"/>
+    
+</context>
Index: NEMO/branches/2019/dev_r11756_SI3restart_XIOS/tests/ICE_AGRIF/EXPREF/1_nemo_rstw.xml
===================================================================
--- NEMO/branches/2019/dev_r11756_SI3restart_XIOS/tests/ICE_AGRIF/EXPREF/1_nemo_rstw.xml	(revision 11924)
+++ NEMO/branches/2019/dev_r11756_SI3restart_XIOS/tests/ICE_AGRIF/EXPREF/1_nemo_rstw.xml	(revision 11924)
@@ -0,0 +1,5 @@
+<context id="1_nemo_rstw">
+  
+    <grid_definition src="./grid_def_nemo.xml"/>
+    
+</context>
Index: NEMO/branches/2019/dev_r11756_SI3restart_XIOS/tests/ICE_AGRIF/EXPREF/1_si3_rst.xml
===================================================================
--- NEMO/branches/2019/dev_r11756_SI3restart_XIOS/tests/ICE_AGRIF/EXPREF/1_si3_rst.xml	(revision 11924)
+++ NEMO/branches/2019/dev_r11756_SI3restart_XIOS/tests/ICE_AGRIF/EXPREF/1_si3_rst.xml	(revision 11924)
@@ -0,0 +1,5 @@
+<context id="1_si3_rst">
+  
+    <grid_definition src="./grid_def_nemo.xml"/>
+    
+</context>
Index: NEMO/branches/2019/dev_r11756_SI3restart_XIOS/tests/ICE_AGRIF/EXPREF/nemo_rstw.xml
===================================================================
--- NEMO/branches/2019/dev_r11756_SI3restart_XIOS/tests/ICE_AGRIF/EXPREF/nemo_rstw.xml	(revision 11924)
+++ NEMO/branches/2019/dev_r11756_SI3restart_XIOS/tests/ICE_AGRIF/EXPREF/nemo_rstw.xml	(revision 11924)
@@ -0,0 +1,5 @@
+<context id="nemo_rstw">
+  
+    <grid_definition src="./grid_def_nemo.xml"/>
+    
+</context>
Index: NEMO/branches/2019/dev_r11756_SI3restart_XIOS/tests/ICE_AGRIF/EXPREF/si3_rst.xml
===================================================================
--- NEMO/branches/2019/dev_r11756_SI3restart_XIOS/tests/ICE_AGRIF/EXPREF/si3_rst.xml	(revision 11924)
+++ NEMO/branches/2019/dev_r11756_SI3restart_XIOS/tests/ICE_AGRIF/EXPREF/si3_rst.xml	(revision 11924)
@@ -0,0 +1,5 @@
+<context id="si3_rst">
+  
+    <grid_definition src="./grid_def_nemo.xml"/>
+    
+</context>